66549723521ac2f57351daaf31a303d2b8d1da8f
[csit.git] / bootstrap-verify-perf-ligato.sh
1 #!/bin/bash
2 # Copyright (c) 2017 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -xo pipefail
16
17 # Space separated list of available testbeds, described by topology files
18 TOPOLOGIES="topologies/available/lf_testbed1.yaml \
19             topologies/available/lf_testbed2.yaml \
20             topologies/available/lf_testbed3.yaml"
21
22 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
23
24 # Reservation dir
25 RESERVATION_DIR="/tmp/reservation_dir"
26 INSTALLATION_DIR="/tmp/install_dir"
27
28 PYBOT_ARGS="-W 150 -L TRACE"
29
30 ARCHIVE_ARTIFACTS=(log.html output.xml report.html output_perf_data.xml)
31
32 # If we run this script from CSIT jobs we want to use stable vpp version
33 if [[ ${JOB_NAME} == csit-* ]] ;
34 then
35     mkdir -p vpp/build-root
36     cd vpp/build-root
37
38     if [[ ${TEST_TAG} == *NIGHTLY ]] || \
39        [[ ${TEST_TAG} == *DAILY ]] || \
40        [[ ${TEST_TAG} == *WEEKLY ]];
41     then
42         # Download the latest VPP build .deb install packages
43         echo Downloading VPP packages...
44         bash ${SCRIPT_DIR}/resources/tools/scripts/download_install_vpp_pkgs.sh --skip-install
45
46         VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
47         # Take vpp package and get the vpp version
48         VPP_STABLE_VER="$( expr match $(ls *.deb | head -n 1) 'vpp-\(.*\)-deb.deb' )"
49     else
50         DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER)_amd64
51         VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_UBUNTU)
52         VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_UBUNTU)
53         VPP_CLASSIFIER="-deb"
54         # Download vpp build from nexus and set VPP_DEBS variable
55         wget -q "${VPP_REPO_URL}/vpp/${VPP_STABLE_VER}/vpp-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
56         wget -q "${VPP_REPO_URL}/vpp-dbg/${VPP_STABLE_VER}/vpp-dbg-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
57         wget -q "${VPP_REPO_URL}/vpp-dev/${VPP_STABLE_VER}/vpp-dev-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
58         # Temporary disable using dpdk
59         # wget -q "${VPP_REPO_URL}/vpp-dpdk-dkms/${DPDK_STABLE_VER}/vpp-dpdk-dkms-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
60         wget -q "${VPP_REPO_URL}/vpp-lib/${VPP_STABLE_VER}/vpp-lib-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
61         wget -q "${VPP_REPO_URL}/vpp-plugins/${VPP_STABLE_VER}/vpp-plugins-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb" || exit
62         VPP_DEBS="$( readlink -f *.deb | tr '\n' ' ' )"
63     fi
64
65     dpkg -x vpp-${VPP_STABLE_VER}${VPP_CLASSIFIER}.deb /tmp/vpp
66     # Temporary workaround as ligato docker file requires specific file name
67     rename -v 's/^(.*)-(\d.*)-deb.deb/$1_$2.deb/' *.deb
68     cd ${SCRIPT_DIR}
69
70 # If we run this script from vpp project we want to use local build
71 elif [[ ${JOB_NAME} == vpp-* ]] ;
72 then
73     mkdir -p vpp/build-root
74     # Use local packages provided as argument list
75     # Jenkins VPP deb paths (convert to full path)
76     VPP_DEBS="$( readlink -f $@ | tr '\n' ' ' )"
77     # Take vpp package and get the vpp version
78     VPP_STABLE_VER="$( expr match $1 'vpp-\(.*\)-deb.deb' )"
79     # Move files to build-root for packing
80     for deb in ${VPP_DEBS}; do mv ${deb} vpp/build-root/; done
81     dpkg -x vpp/build-root/vpp_${VPP_STABLE_VER}.deb /tmp/vpp
82 else
83     echo "Unable to identify job type based on JOB_NAME variable: ${JOB_NAME}"
84     exit 1
85 fi
86
87 # Compress all VPP debs and remove temporary directory
88 tar -zcvf ${SCRIPT_DIR}/vpp.tar.gz vpp/*  && rm -R vpp
89
90 LIGATO_REPO_URL=$(cat ${SCRIPT_DIR}/LIGATO_REPO_URL)
91 VPP_AGENT_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_AGENT_STABLE_VER)
92 VPP_AGENT_STABLE_COMMIT="$( expr match `cat VPP_AGENT_STABLE_VER` '.*g\(.*\)' )"
93 DOCKER_DEB="docker-ce_17.09.0~ce-0~ubuntu_amd64.deb"
94
95 # Clone & checkout stable vnf-agent
96 cd .. && git clone ${LIGATO_REPO_URL}/vpp-agent
97 # If the git clone fails, complain clearly and exit
98 if [ $? != 0 ]; then
99     echo "Failed to run: git clone --depth 1 ${LIGATO_REPO_URL}/vpp-agent"
100     exit 1
101 fi
102 cd vpp-agent && git checkout ${VPP_AGENT_STABLE_COMMIT}
103 # If the git checkout fails, complain clearly and exit
104 if [ $? != 0 ]; then
105     echo "Failed to run: git checkout ${VPP_AGENT_STABLE_VER}"
106     exit 1
107 fi
108
109 # Install Docker
110 wget -q https://download.docker.com/linux/ubuntu/dists/xenial/pool/stable/amd64/${DOCKER_DEB}
111 sudo dpkg -i ${DOCKER_DEB}
112 # If installation fails, complain clearly and exit
113 if [ $? != 0 ]; then
114     echo "Failed to install Docker"
115     exit 1
116 fi
117
118 # Pull ligato/dev_vpp_agent docker image and re-tag as local
119 sudo docker pull ligato/dev-vpp-agent:${VPP_AGENT_STABLE_VER}
120 sudo docker tag ligato/dev-vpp-agent:${VPP_AGENT_STABLE_VER}\
121     dev_vpp_agent:latest
122 sudo docker images
123
124 # Start dev_vpp_agent container as daemon
125 sudo docker run --rm -itd --name agentcnt dev_vpp_agent bash
126 # Copy latest vpp api into running container
127 sudo docker cp /tmp/vpp/usr/share/vpp/api agentcnt:/usr/share/vpp
128 # Recompile vpp-agent
129 sudo docker exec -i agentcnt \
130     script -qc '. ~/.bashrc; cd /root/go/src/github.com/ligato/vpp-agent && make generate && make install'
131 # Extract vpp-agent
132 rm -rf agent
133 mkdir -p agent
134 sudo docker cp agentcnt:/root/go/bin/vpp-agent agent/
135 sudo docker cp agentcnt:/root/go/bin/vpp-agent-ctl agent/
136 sudo docker cp agentcnt:/root/go/bin/agentctl agent/
137 tar -zcvf ${SCRIPT_DIR}/../vpp-agent/docker/prod_vpp_agent/agent.tar.gz agent
138 # Kill running container
139 sudo docker rm -f agentcnt
140
141 # Build prod_vpp_agent docker image
142 cd ${SCRIPT_DIR}/../vpp-agent/docker/prod_vpp_agent/ &&\
143     mv ${SCRIPT_DIR}/vpp.tar.gz . &&\
144     sudo docker build -t prod_vpp_agent --no-cache .
145 # Export Docker image
146 sudo docker save prod_vpp_agent | gzip > prod_vpp_agent.tar.gz
147 # If image build fails, complain clearly and exit
148 if [ $? != 0 ]; then
149     echo "Failed to build vpp-agent Docker image."
150     exit 1
151 fi
152 DOCKER_IMAGE="$( readlink -f prod_vpp_agent.tar.gz | tr '\n' ' ' )"
153
154 cd ${SCRIPT_DIR}
155
156 sudo apt-get -y update
157 sudo apt-get -y install libpython2.7-dev python-virtualenv
158
159 WORKING_TOPOLOGY=""
160 export PYTHONPATH=${SCRIPT_DIR}
161
162 virtualenv --system-site-packages env
163 . env/bin/activate
164
165 echo pip install
166 pip install -r requirements.txt
167
168 # We iterate over available topologies and wait until we reserve topology
169 while :; do
170     for TOPOLOGY in ${TOPOLOGIES};
171     do
172         python ${SCRIPT_DIR}/resources/tools/scripts/topo_reservation.py -t ${TOPOLOGY}
173         if [ $? -eq 0 ]; then
174             WORKING_TOPOLOGY=${TOPOLOGY}
175             echo "Reserved: ${WORKING_TOPOLOGY}"
176             break
177         fi
178     done
179
180     if [ ! -z "${WORKING_TOPOLOGY}" ]; then
181         # Exit the infinite while loop if we made a reservation
182         break
183     fi
184
185     # Wait ~3minutes before next try
186     SLEEP_TIME=$[ ( $RANDOM % 20 ) + 180 ]s
187     echo "Sleeping ${SLEEP_TIME}"
188     sleep ${SLEEP_TIME}
189 done
190
191 function cancel_all {
192     python ${SCRIPT_DIR}/resources/tools/scripts/topo_container_copy.py -c -d ${INSTALLATION_DIR} -t $1
193     python ${SCRIPT_DIR}/resources/tools/scripts/topo_reservation.py -c -t $1
194 }
195
196 # On script exit we cancel the reservation and installation and delete all vpp
197 # packages
198 trap "cancel_all ${WORKING_TOPOLOGY}" EXIT
199
200 python ${SCRIPT_DIR}/resources/tools/scripts/topo_container_copy.py\
201     -t ${WORKING_TOPOLOGY} -d ${INSTALLATION_DIR} -i ${DOCKER_IMAGE}
202 if [ $? -eq 0 ]; then
203     echo "Docker image copied and loaded on hosts from: ${WORKING_TOPOLOGY}"
204 else
205     echo "Failed to copy and load Docker image to DUTs"
206     exit 1
207 fi
208
209 case "$TEST_TAG" in
210     # run specific performance tests based on jenkins job type variable
211     PERFTEST_DAILY )
212         pybot ${PYBOT_ARGS} \
213               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
214               -v DPDK_TEST:True \
215               -s "tests.kubernetes.perf" \
216               --include ndrdiscANDnic_intel-x520-da2AND1t1cORndrdiscANDnic_intel-x520-da2AND2t2c \
217               tests/
218         RETURN_STATUS=$(echo $?)
219         ;;
220     PERFTEST_SEMI_WEEKLY )
221         pybot ${PYBOT_ARGS} \
222               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
223               -v DPDK_TEST:True \
224               -s "tests.kubernetes.perf" \
225               --include ndrdiscANDnic_intel-x710AND1t1cORndrdiscANDnic_intel-x710AND2t2cORndrdiscANDnic_intel-xl710AND1t1cORndrdiscANDnic_intel-xl710AND2t2c \
226               tests/
227         RETURN_STATUS=$(echo $?)
228         ;;
229     VERIFY-PERF-NDRDISC )
230         pybot ${PYBOT_ARGS} \
231               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
232               -v DPDK_TEST:True \
233               -s "tests.kubernetes.perf" \
234               --include ndrdiscAND1t1cORndrdiscAND2t2c \
235               tests/
236         RETURN_STATUS=$(echo $?)
237         ;;
238     VERIFY-PERF-PDRDISC )
239         pybot ${PYBOT_ARGS} \
240               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
241               -v DPDK_TEST:True \
242               -s "tests.kubernetes.perf" \
243               --include pdrdiscAND1t1cORpdrdiscAND2t2c \
244               tests/
245         RETURN_STATUS=$(echo $?)
246         ;;
247     VERIFY-PERF-NDRCHK )
248         pybot ${PYBOT_ARGS} \
249               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
250               -v DPDK_TEST:True \
251               -s "tests.kubernetes.perf" \
252               --include ndrchkAND1t1cORndrchkAND2t2c \
253               tests/
254         RETURN_STATUS=$(echo $?)
255         ;;
256     PERFTEST_NDRCHK_DAILY )
257         pybot ${PYBOT_ARGS} \
258               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
259               -v DPDK_TEST:True \
260               -s "tests.kubernetes.perf" \
261               --include ndrchkAND1t1cORndrchkAND2t2c \
262               tests/
263         RETURN_STATUS=$(echo $?)
264         ;;
265     VERIFY-PERF-IP4 )
266         pybot ${PYBOT_ARGS} \
267               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
268               -v DPDK_TEST:True \
269               -s "tests.kubernetes.perf" \
270               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip4baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
271               tests/
272         RETURN_STATUS=$(echo $?)
273         ;;
274     VERIFY-PERF-IP6 )
275         pybot ${PYBOT_ARGS} \
276               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
277               -v DPDK_TEST:True \
278               -s "tests.kubernetes.perf" \
279               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDip6baseORndrdiscANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
280               tests/
281         RETURN_STATUS=$(echo $?)
282         ;;
283     VERIFY-PERF-L2 )
284         pybot ${PYBOT_ARGS} \
285               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
286               -v DPDK_TEST:True \
287               -s "tests.kubernetes.perf" \
288               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDl2xcbaseORndrdiscANDnic_intel-x520-da2AND1t1cANDl2bdbase \
289               tests/
290         RETURN_STATUS=$(echo $?)
291         ;;
292     VERIFY-PERF-LISP )
293         pybot ${PYBOT_ARGS} \
294               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
295               -v DPDK_TEST:True \
296               -s "tests.kubernetes.perf" \
297               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDlisp \
298               tests/
299         RETURN_STATUS=$(echo $?)
300         ;;
301     VERIFY-PERF-VXLAN )
302         pybot ${PYBOT_ARGS} \
303               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
304               -v DPDK_TEST:True \
305               -s "tests.kubernetes.perf" \
306               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvxlan \
307               tests/
308         RETURN_STATUS=$(echo $?)
309         ;;
310     VERIFY-PERF-VHOST )
311         pybot ${PYBOT_ARGS} \
312               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
313               -v DPDK_TEST:True \
314               -s "tests.kubernetes.perf" \
315               --include ndrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
316               tests/
317         RETURN_STATUS=$(echo $?)
318         ;;
319     VPP-VERIFY-PERF-IP4 )
320         pybot ${PYBOT_ARGS} \
321               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
322               -v DPDK_TEST:True \
323               -s "tests.kubernetes.perf" \
324               --include pdrchkANDnic_intel-x520-da2AND1t1cANDip4baseORpdrchkANDnic_intel-x520-da2AND1t1cANDip4fwdANDfib_2m \
325               tests/
326         RETURN_STATUS=$(echo $?)
327         ;;
328     VPP-VERIFY-PERF-IP6 )
329         pybot ${PYBOT_ARGS} \
330               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
331               -v DPDK_TEST:True \
332               -s "tests.kubernetes.perf" \
333               --include pdrchkANDnic_intel-x520-da2AND1t1cANDip6baseORpdrchkANDnic_intel-x520-da2AND1t1cANDip6fwdANDfib_2m \
334               tests/
335         RETURN_STATUS=$(echo $?)
336         ;;
337     VPP-VERIFY-PERF-L2 )
338         pybot ${PYBOT_ARGS} \
339               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
340               -v DPDK_TEST:True \
341               -s "tests.kubernetes.perf" \
342               --include pdrchkANDnic_intel-x520-da2AND1t1cANDl2xcbaseORpdrchkANDnic_intel-x520-da2AND1t1cANDl2bdbase \
343               tests/
344         RETURN_STATUS=$(echo $?)
345         ;;
346     VPP-VERIFY-PERF-LISP )
347         pybot ${PYBOT_ARGS} \
348               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
349               -v DPDK_TEST:True \
350               -s "tests.kubernetes.perf" \
351               --include pdrchkANDnic_intel-x520-da2AND1t1cANDlisp \
352               tests/
353         RETURN_STATUS=$(echo $?)
354         ;;
355     VPP-VERIFY-PERF-VXLAN )
356         pybot ${PYBOT_ARGS} \
357               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
358               -v DPDK_TEST:True \
359               -s "tests.kubernetes.perf" \
360               --include pdrchkANDnic_intel-x520-da2AND1t1cANDvxlan \
361               tests/
362         RETURN_STATUS=$(echo $?)
363         ;;
364     VPP-VERIFY-PERF-VHOST )
365         pybot ${PYBOT_ARGS} \
366               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
367               -v DPDK_TEST:True \
368               -s "tests.kubernetes.perf" \
369               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDvhost \
370               tests/
371         RETURN_STATUS=$(echo $?)
372         ;;
373     VPP-VERIFY-PERF-ACL )
374         pybot ${PYBOT_ARGS} \
375               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
376               -v DPDK_TEST:True \
377               -s "tests.kubernetes.perf" \
378               --include pdrdiscANDnic_intel-x520-da2AND1t1cANDacl \
379               --include pdrdiscANDnic_intel-x520-da2AND2t2cANDacl \
380               tests/
381         RETURN_STATUS=$(echo $?)
382         ;;
383     PERFTEST_LONG )
384         pybot ${PYBOT_ARGS} \
385               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
386               -v DPDK_TEST:True \
387               -s "tests.kubernetes.perf" \
388               --exclude SKIP_PATCH \
389               -i NDRPDRDISC \
390               tests/
391         RETURN_STATUS=$(echo $?)
392         ;;
393     PERFTEST_SHORT )
394         pybot ${PYBOT_ARGS} \
395               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
396               -v DPDK_TEST:True \
397               -s "tests.kubernetes.perf" \
398               -i NDRCHK \
399               tests/
400         RETURN_STATUS=$(echo $?)
401         ;;
402     PERFTEST_NIGHTLY )
403         #run all available tests
404         pybot ${PYBOT_ARGS} \
405               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
406               -v DPDK_TEST:True \
407               -s "tests.kubernetes.perf" \
408               tests/
409         RETURN_STATUS=$(echo $?)
410         ;;
411     * )
412         # run full performance test suite and exit on fail
413         pybot ${PYBOT_ARGS} \
414               -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
415               -v DPDK_TEST:True \
416               -s "tests.kubernetes.perf" \
417               tests/
418         RETURN_STATUS=$(echo $?)
419 esac
420
421 # Pybot output post-processing
422 echo Post-processing test data...
423
424 python ${SCRIPT_DIR}/resources/tools/scripts/robot_output_parser.py \
425        -i ${SCRIPT_DIR}/output.xml \
426        -o ${SCRIPT_DIR}/output_perf_data.xml \
427        -v ${VPP_STABLE_VER}
428 if [ ! $? -eq 0 ]; then
429     echo "Parsing ${SCRIPT_DIR}/output.xml failed"
430 fi
431
432 # Archive artifacts
433 mkdir -p archive
434 for i in ${ARCHIVE_ARTIFACTS[@]}; do
435     cp $( readlink -f ${i} | tr '\n' ' ' ) archive/
436 done
437
438 echo Post-processing finished.
439
440 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.